#!/usr/bin/env python
from .interfaces import Map
from .term_manager import TermManager


def proof_of_concept() -> None:
    m = Map.load("example_map.txt")

    with TermManager() as term_manager:
        stdscr = term_manager.screen

        stdscr.addstr(0, 0, m.draw_string())
        stdscr.refresh()

        cur = [1, 6]    # (y,x)
        stdscr.addstr(1, 6, '🐿️')
        stdscr.refresh()

        while True:
            key = stdscr.getkey()
            stdscr.addstr(cur[0], cur[1], '.')
            next_pos = cur[:]
            if key == 'z' or key == 'KEY_UP':
                next_pos[0] = cur[0] - 1
            if key == 's' or key == 'KEY_DOWN':
                next_pos[0] = cur[0] + 1
            if key == 'q' or key == 'KEY_LEFT':
                next_pos[1] = cur[1] - 1
            if key == 'd' or key == 'KEY_RIGHT':
                next_pos[1] = cur[1] + 1
            if 0 <= next_pos[0] < m.height and 0 <= next_pos[0] < m.width:
                next_tile = m.tiles[next_pos[0]][next_pos[1]]
                if next_tile.can_walk():
                    cur = next_pos
            stdscr.addstr(cur[0], cur[1], '🐿️')
